'use strict';
angular.module('aom.directives')
  .directive('aomCounter', function ($timeout) {
    return {
      scope: {
        object: '=',
        readonly: '=',
        changedMethod: '='
      },
      link: function ($scope) {
        $scope.object.Data = '' + Math.round($scope.object.Data);
        var calcTimeout = null;
        var currentValue = angular.copy($scope.object.Data);
        $scope.object.Options.CounterStep = $scope.object.Options.CounterStep === undefined ? 0 : Math.round($scope.object.Options.CounterStep);

        function action(add = true) {
          if (calcTimeout !== null) {
            $timeout.cancel(calcTimeout);
          }
          if (!$scope.readonly) {
            if (add) {
              currentValue = parseInt(currentValue) + $scope.object.Options.CounterStep;
            } else {
              currentValue = parseInt(currentValue) - $scope.object.Options.CounterStep;
            }
            calcTimeout = $timeout(function () {
              $scope.object.Data = '' + currentValue;
              $scope.changedMethod($scope.object.Name);
            }, 500);
          }
        }

        $scope.add = function () {
          action();
        };

        $scope.subtract = function () {
          action(false);
        };

      },
      templateUrl: 'App/Common/Directives/Counter/counter.html'
    };
  });