'use strict';
angular.module('aom.services')
  .factory('aomBackSrv', function ($rootScope, $ionicPlatform) {
    var back = {};

    back.model = {
      ionicBack: angular.copy($rootScope.$ionicGoBack),
      backArray: [],
      deregisterHardBack: [],
      deregisterSoftBack: null
    };

    back.init = function (tempBack, level) {
      level = level === undefined ? 101 : level;
      back.model.backArray.push($rootScope.$ionicGoBack);
      $rootScope.$ionicGoBack = tempBack;
      back.model.deregisterHardBack.push($ionicPlatform.registerBackButtonAction(
        tempBack, level
      ));
      back.model.deregisterSoftBack = function () {
        $rootScope.$ionicGoBack = back.model.backArray.pop();
      };
    };

    back.exit = function (triggerBack) {
      back.model.deregisterHardBack.pop()();
      back.model.deregisterSoftBack();
    };

    back.clear = function () {
      for (var i = 0; i < back.model.deregisterHardBack.length; i++) {
        back.model.deregisterHardBack[i]();
      }
      $rootScope.$ionicGoBack = angular.copy(back.model.ionicBack);
      back.model.backArray.length = 0;
      back.model.deregisterHardBack.length = 0;
    };

    return back;
  });