'use strict';
angular.module('aom.services')
  .factory('aomLogSrv', function ($rootScope, constants) {
    var logService = {};

    logService = constants.logging;

    logService.log = function (object, level, severity) {
      if (object && level && severity) {
        //TODO need to add function name to message
        if (object.error) {
          try {
            object.error = JSON.stringify(object.error).substr(0, 2500);
          } catch (err) {
            object.error = 'Failed to stringify error for "' + object.message + '"';
          }
        }
        $rootScope.$emit('aomLog', { object: object, level: level, severity: severity, time: moment().format('YYYY-MM-DD HH:mm:ss:SS') });
      } else {
        console.log('Invalid log sent to aomLogSrv');
      }
    };

    return logService;
  });